<?php
/*
	[UCenter Home] (C) 2007-2008 Comsenz Inc.
	$Id: function_delete.php 7591 2008-06-13 10:29:21Z liguode $
*/

if(!defined('IN_UCHOME')) {
	exit('Access Denied');
}

//ɾ
function deletecomments($cids) {
	global $_SGLOBAL;
	
	$blognums = $spaces = $newcids = $dels = array();
	$allowmanage = checkperm('managecomment');
	$query = $_SGLOBAL['db']->query("SELECT * FROM ".tname('comment')." WHERE cid IN (".simplode($cids).")");
	while ($value = $_SGLOBAL['db']->fetch_array($query)) {
		if($allowmanage || $value['authorid'] == $_SGLOBAL['supe_uid'] || $value['uid'] == $_SGLOBAL['supe_uid']) {
			$newcids[] = $value['cid'];
			if($value['idtype'] == 'blogid') {
				$blognums[$value['id']]++;
			}
			if($value['authorid'] != $value['uid']) {
				$spaces[$value['authorid']]++;
			}
			$dels[] = $value;
		}
	}
	if(empty($dels)) return array();
	
	//ɾ
	$_SGLOBAL['db']->query("DELETE FROM ".tname('comment')." WHERE cid IN (".simplode($newcids).")");

	//ͳ
	$nums = renum($blognums);
	foreach ($nums[0] as $num) {
		$_SGLOBAL['db']->query("UPDATE ".tname('blog')." SET replynum=replynum-$num WHERE blogid IN (".simplode($nums[1][$num]).")");
	}
	
	//
	if($spaces) {
		updatespaces($spaces, 'comment');
	}

	return $dels;
}

//ɾ
function deleteblogs($blogids) {
	global $_SGLOBAL;
	
	//ȡϢ
	$spaces = $blogs = $newblogids = array();
	$allowmanage = checkperm('manageblog');
	$query = $_SGLOBAL['db']->query("SELECT * FROM ".tname('blog')." WHERE blogid IN (".simplode($blogids).")");
	while ($value = $_SGLOBAL['db']->fetch_array($query)) {
		if($allowmanage || $value['uid'] == $_SGLOBAL['supe_uid']) {
			$blogs[] = $value;
			$newblogids[] = $value['blogid'];
			//Ҫͳ
			//ռ
			$spaces[$value['uid']]++;
			//tag
			$tags = array();
			$subquery = $_SGLOBAL['db']->query("SELECT tagid, blogid FROM ".tname('tagblog')." WHERE blogid='$value[blogid]'");
			while ($tag = $_SGLOBAL['db']->fetch_array($subquery)) {
				$tags[] = $tag['tagid'];
			}
			if($tags) {
				$_SGLOBAL['db']->query("UPDATE ".tname('tag')." SET blognum=blognum-1 WHERE tagid IN (".simplode($tags).")");
				$_SGLOBAL['db']->query("DELETE FROM ".tname('tagblog')." WHERE blogid='$value[blogid]'");
			}
		}
	}
	if(empty($blogs)) return array();

	//ռ
	updatespaces($spaces, 'blog');

	//ɾ
	$_SGLOBAL['db']->query("DELETE FROM ".tname('blog')." WHERE blogid IN (".simplode($newblogids).")");
	$_SGLOBAL['db']->query("DELETE FROM ".tname('blogfield')." WHERE blogid IN (".simplode($newblogids).")");
	
	//
	$_SGLOBAL['db']->query("DELETE FROM ".tname('comment')." WHERE id IN (".simplode($newblogids).") AND idtype='blogid'");
	
	return $blogs;
}

//ɾ¼
function deletefeeds($feedids) {
	global $_SGLOBAL;
	
	$allowmanage = checkperm('managefeed');

	$feeds = $newfeedids = array();
	$query = $_SGLOBAL['db']->query("SELECT * FROM ".tname('feed')." WHERE feedid IN (".simplode($feedids).")");
	while ($value = $_SGLOBAL['db']->fetch_array($query)) {
		if($allowmanage || $value['uid'] == $_SGLOBAL['supe_uid']) {//Ա/
			$newfeedids[] = $value['feedid'];
			$feeds[] = $value;
		}
	}
	if(empty($newfeedids)) return array();
	
	$_SGLOBAL['db']->query("DELETE FROM ".tname('feed')." WHERE feedid IN (".simplode($newfeedids).")");

	return $feeds;
}


//ɾ
function deleteshares($sids) {
	global $_SGLOBAL;
	
	$allowmanage = checkperm('manageshare');

	$shares = $newsids = array();
	$query = $_SGLOBAL['db']->query("SELECT * FROM ".tname('share')." WHERE sid IN (".simplode($sids).")");
	while ($value = $_SGLOBAL['db']->fetch_array($query)) {
		if($allowmanage || $value['uid'] == $_SGLOBAL['supe_uid']) {//Ա/
			$newsids[] = $value['sid'];
			$shares[] = $value;
		}
	}
	if(empty($newsids)) return array();
	
	$_SGLOBAL['db']->query("DELETE FROM ".tname('share')." WHERE sid IN (".simplode($newsids).")");

	return $shares;
}


//ɾ㲩
function deletedoings($ids) {
	global $_SGLOBAL;
	
	$allowmanage = checkperm('managedoing');

	$doings = $newdoids = array();
	$query = $_SGLOBAL['db']->query("SELECT * FROM ".tname('doing')." WHERE doid IN (".simplode($ids).")");
	while ($value = $_SGLOBAL['db']->fetch_array($query)) {
		if($allowmanage || $value['uid'] == $_SGLOBAL['supe_uid']) {//Ա/
			$newdoids[] = $value['doid'];
			$doings[] = $value;
		}
	}
	if(empty($newdoids)) return array();
	
	$_SGLOBAL['db']->query("DELETE FROM ".tname('doing')." WHERE doid IN (".simplode($newdoids).")");

	return $doings;
}

//ɾ
function deletethreads($tids) {
	global $_SGLOBAL;
	
	$tnums = $pnums = $delthreads = $newids = $spaces = array();
	$allowmanage = checkperm('managethread');
	
	$query = $_SGLOBAL['db']->query("SELECT t.*, mt.moderator FROM ".tname('thread')." t LEFT JOIN ".tname('mtag')." mt ON mt.tagid=t.tagid WHERE t.tid IN(".simplode($tids).")");
	while ($value = $_SGLOBAL['db']->fetch_array($query)) {
		if($allowmanage || $value['uid'] == $_SGLOBAL['supe_uid'] || ismoderator($value['moderator'])) {
			$newids[] = $value['tid'];
			$value['isthread'] = 1;
			$delthreads[] = $value;
			$spaces[$value['uid']]++;
		}
	}
	if(empty($delthreads)) return array();

	//ɾ
	$_SGLOBAL['db']->query("DELETE FROM ".tname('thread')." WHERE tid IN(".simplode($newids).")");
	$_SGLOBAL['db']->query("DELETE FROM ".tname('post')." WHERE tid IN(".simplode($newids).")");
	
	//
	updatespaces($spaces, 'thread');
	
	return $delthreads;
}

//ɾ
function deleteposts($pids) {
	global $_SGLOBAL;
	
	//ͳ
	$postnums = $mpostnums = $tids = $delposts = $newids = $spaces = array();
	$allowmanage = checkperm('managethread');
	
	$query = $_SGLOBAL['db']->query("SELECT p.*, mt.moderator FROM ".tname('post')." p LEFT JOIN ".tname('mtag')." mt ON mt.tagid=p.tagid WHERE p.pid IN (".simplode($pids).") ORDER BY p.isthread DESC");
	while ($value = $_SGLOBAL['db']->fetch_array($query)) {
		if($allowmanage || $value['uid'] == $_SGLOBAL['supe_uid'] || ismoderator($value['moderator'])) {
			if($value['isthread']) {
				$tids[] = $value['tid'];
			} else {
				if(!in_array($value['tid'], $tids)) {
					$newids[] = $value['pid'];
					$delposts[] = $value;
					$postnums[$value['tid']]++;
					$spaces[$value['uid']]++;
				}
			}
		}
	}
	$delthreads = array();
	if($tids) {
		$delthreads = deletethreads($tids);
	}
	if(empty($delposts)) {
		return $delthreads;
	}

	//
	$nums = renum($postnums);
	foreach ($nums[0] as $pnum) {
		$_SGLOBAL['db']->query("UPDATE ".tname('thread')." SET replynum=replynum-$pnum WHERE tid IN (".simplode($nums[1][$pnum]).")");
	}

	//ɾ
	$_SGLOBAL['db']->query("DELETE FROM ".tname('post')." WHERE pid IN (".simplode($newids).")");
	
	//
	updatespaces($spaces, 'post');

	return $delposts;
}

//ɾռ
function deletespace($uid) {
	global $_SGLOBAL, $_SC;
	
	$delspace = array();
	$allowmanage = checkperm('managespace');
	$query = $_SGLOBAL['db']->query("SELECT * FROM ".tname('space')." WHERE uid='$uid'");
	if($value = $_SGLOBAL['db']->fetch_array($query)) {
		if($allowmanage && $value['uid'] != $_SGLOBAL['supe_uid']) {
			$delspace = $value;
		}
	}
	if(empty($delspace)) return array();
	
	//space
	$_SGLOBAL['db']->query("DELETE FROM ".tname('space')." WHERE uid='$uid'");
	//spacefield
	$_SGLOBAL['db']->query("DELETE FROM ".tname('spacefield')." WHERE uid='$uid'");
	
	//feed
	$_SGLOBAL['db']->query("DELETE FROM ".tname('feed')." WHERE uid='$uid'");

	//
	$_SGLOBAL['db']->query("DELETE FROM ".tname('album')." WHERE uid='$uid'");
	
	//pic
	//ɾͼƬ
	$pics = array();
	$query = $_SGLOBAL['db']->query("SELECT filepath FROM ".tname('pic')." WHERE uid='$uid'");
	while ($value = $_SGLOBAL['db']->fetch_array($query)) {
		$pics[] = $value;
	}
	//
	$_SGLOBAL['db']->query("DELETE FROM ".tname('pic')." WHERE uid='$uid'");

	//blog
	$blogids = array();
	$query = $_SGLOBAL['db']->query("SELECT blogid FROM ".tname('blog')." WHERE uid='$uid'");
	while ($value = $_SGLOBAL['db']->fetch_array($query)) {
		$blogids[$value['blogid']] = $value['blogid'];
		//tag
		$tags = array();
		$subquery = $_SGLOBAL['db']->query("SELECT tagid, blogid FROM ".tname('tagblog')." WHERE blogid='$value[blogid]'");
		while ($tag = $_SGLOBAL['db']->fetch_array($subquery)) {
			$tags[$tag['tagid']] = $tag['tagid'];
		}
		if($tags) {
			$_SGLOBAL['db']->query("UPDATE ".tname('tag')." SET blognum=blognum-1 WHERE tagid IN (".simplode($tags).")");
			$_SGLOBAL['db']->query("DELETE FROM ".tname('tagblog')." WHERE blogid='$value[blogid]'");
		}
	}
	//ɾ
	$_SGLOBAL['db']->query("DELETE FROM ".tname('blog')." WHERE uid='$uid'");
	$_SGLOBAL['db']->query("DELETE FROM ".tname('blogfield')." WHERE uid='$uid'");

	//
	$_SGLOBAL['db']->query("DELETE FROM ".tname('comment')." WHERE uid='$uid'");
	$_SGLOBAL['db']->query("DELETE FROM ".tname('comment')." WHERE authorid='$uid'");
	$_SGLOBAL['db']->query("DELETE FROM ".tname('comment')." WHERE id='$uid' AND idtype='uid'");

	//class
	$_SGLOBAL['db']->query("DELETE FROM ".tname('class')." WHERE uid='$uid'");
	
	//friend
	//
	$_SGLOBAL['db']->query("DELETE FROM ".tname('friend')." WHERE uid='$uid'");
	$_SGLOBAL['db']->query("DELETE FROM ".tname('friend')." WHERE fuid='$uid'");

	//member
	$_SGLOBAL['db']->query("DELETE FROM ".tname('member')." WHERE uid='$uid'");
	
	//mtag
	//thread
	//
	$_SGLOBAL['db']->query("UPDATE ".tname('post')." SET message='' WHERE uid='$uid'");
	
	//session
	$_SGLOBAL['db']->query("DELETE FROM ".tname('session')." WHERE uid='$uid'");
	
	//ѡ
	$mtagids = array();
	$query = $_SGLOBAL['db']->query("SELECT * FROM ".tname('tagspace')." WHERE uid='$uid'");
	while ($value = $_SGLOBAL['db']->fetch_array($query)) {
		$mtagids[$value['tagid']] = $value['tagid'];
	}
	if($mtagids) {
		$_SGLOBAL['db']->query("UPDATE ".tname('mtag')." SET membernum=membernum-1 WHERE tagid IN (".simplode($mtagids).")");
		$_SGLOBAL['db']->query("DELETE FROM ".tname('tagspace')." WHERE uid='$uid'");
	}

	//ɾͼƬ
	deletepicfiles($pics);//ɾͼƬ
	
	return $delspace;
}

//ɾͼƬ
function deletepics($picids) {
	global $_SGLOBAL, $_SC;
	
	$delpics = $albumnums = $newids = $sizes = $auids = $spaces = array();
	$allowmanage = checkperm('managealbum');
	
	$pics = array();
	$query = $_SGLOBAL['db']->query("SELECT * FROM ".tname('pic')." WHERE picid IN (".simplode($picids).")");
	while ($value = $_SGLOBAL['db']->fetch_array($query)) {
		if($allowmanage || $value['uid'] == $_SGLOBAL['supe_uid']) {
			//ɾļ
			$pics[] = $value;
			$newids[] = $value['picid'];
			$delpics[] = $value;
			$allsize = $allsize + $value['size'];
			$sizes[$value['uid']] = $sizes[$value['uid']] + $value['size'];
			if($value['albumid']) {
				$auids[$value['albumid']] = $value['uid'];
				$albumnums[$value['albumid']]++;
			}
			$spaces[$value['uid']]++;
		}
	}
	if(empty($delpics)) return array();
	
	if($sizes) {
		$nums = renum($sizes);
		foreach ($nums[0] as $num) {
			$_SGLOBAL['db']->query("UPDATE ".tname('space')." SET attachsize=attachsize-$num WHERE uid IN (".simplode($nums[1][$num]).")");
		}
	}
	if($newids) {
		$_SGLOBAL['db']->query("DELETE FROM ".tname('pic')." WHERE picid IN (".simplode($newids).")");
		$_SGLOBAL['db']->query("DELETE FROM ".tname('comment')." WHERE id IN (".simplode($newids).") AND idtype='picid'");
	}
	if($albumnums) {
		include_once(S_ROOT.'./source/function_cp.php');
		foreach ($albumnums as $id => $num) {
			$thepic = getalbumpic($auids[$id], $id);
			$_SGLOBAL['db']->query("UPDATE ".tname('album')." SET pic='$thepic', picnum=picnum-$num WHERE albumid='$id'");
		}
	}
	
	//ɾͼƬ
	deletepicfiles($pics);

	return $delpics;
}

//ɾͼƬļ
function deletepicfiles($pics) {
	global $_SGLOBAL, $_SC;
	$remotes = array();
	foreach ($pics as $pic) {
		if($pic['remote']) {
			$remotes[] = $pic;
		} else {
			$file = $_SC['attachdir'].'./'.$pic['filepath'];
			if(!@unlink($file)) {
				runlog('PIC', "Delete pic file '$file' error.", 0);
			}
			if($pic['thumb']) {
				if(!@unlink($file.'.thumb.jpg')) {
					runlog('PIC', "Delete pic file '{$file}.thumb.jpg' error.", 0);
				}
			}
		}
	}
	//ɾԶ̸
	if($remotes) {
		include_once(S_ROOT.'./data/data_setting.php');
		include_once(S_ROOT.'./source/function_ftp.php');
		$ftpconnid = sftp_connect();
		foreach ($remotes as $pic) {
			$file = $pic['filepath'];
			if($ftpconnid) {
				if(!sftp_delete($ftpconnid, $file)) {
					runlog('FTP', "Delete pic file '$file' error.", 0);
				}
				if($pic['thumb'] && !sftp_delete($ftpconnid, $file.'.thumb.jpg')) {
					runlog('FTP', "Delete pic file '{$file}.thumb.jpg' error.", 0);
				}
			} else {
				runlog('FTP', "Delete pic file '$file' error.", 0);
				if($pic['thumb']) {
					runlog('FTP', "Delete pic file '{$file}.thumb.jpg' error.", 0);
				}
			}
		}
	}
}

//ɾ
function deletealbums($albumids) {
	global $_SGLOBAL, $_SC;
	
	$dels = $newids = $sizes = $spaces = array();
	$allowmanage = checkperm('managealbum');

	$query = $_SGLOBAL['db']->query("SELECT * FROM ".tname('album')." WHERE albumid IN (".simplode($albumids).")");
	while ($value = $_SGLOBAL['db']->fetch_array($query)) {
		if($allowmanage || $value['uid'] == $_SGLOBAL['supe_uid']) {
			$dels[] = $value;
			$newids[] = $value['albumid'];
		}
	}
	if(empty($dels)) return array();

	$pics = array();
	$query = $_SGLOBAL['db']->query("SELECT * FROM ".tname('pic')." WHERE albumid IN (".simplode($newids).")");
	while ($value = $_SGLOBAL['db']->fetch_array($query)) {
		$sizes[$value['uid']] = $sizes[$value['uid']] + $value['size'];
		$pics[] = $value;
		$spaces[$value['uid']]++;
	}
	
	if($sizes) {
		$nums = renum($sizes);
		foreach ($nums[0] as $num) {
			$_SGLOBAL['db']->query("UPDATE ".tname('space')." SET attachsize=attachsize-$num WHERE uid IN (".simplode($nums[1][$num]).")");
		}
		$_SGLOBAL['db']->query("DELETE FROM ".tname('pic')." WHERE albumid IN (".simplode($newids).")");
	}
	
	$_SGLOBAL['db']->query("DELETE FROM ".tname('album')." WHERE albumid IN (".simplode($newids).")");
	
	//ɾͼƬ
	if($pics) {
		deletepicfiles($pics);//ɾͼƬ
	}

	return $dels;
}

//ɾtag
function deletetags($tagids) {
	global $_SGLOBAL;
	
	if(!checkperm('managetag')) return false;

	//
	$_SGLOBAL['db']->query("DELETE FROM ".tname('tagblog')." WHERE tagid IN (".simplode($tagids).")");
	$_SGLOBAL['db']->query("DELETE FROM ".tname('tag')." WHERE tagid IN (".simplode($tagids).")");
	
	return true;
}

//ɾmtag
function deletemtag($tagids) {
	global $_SGLOBAL;

	if(!checkperm('manageprofield') && !checkperm('managemtag')) return array();
	
	$dels = $newids = array();
	$query = $_SGLOBAL['db']->query("SELECT * FROM ".tname('mtag')." WHERE tagid IN (".simplode($tagids).")");
	while ($value = $_SGLOBAL['db']->fetch_array($query)) {
		$newids[] = $value['tagid'];
		$dels[] = $value;
	}
	if(empty($newids)) return array();
	
	//
	$_SGLOBAL['db']->query("DELETE FROM ".tname('tagspace')." WHERE tagid IN (".simplode($newids).")");
	$_SGLOBAL['db']->query("DELETE FROM ".tname('mtag')." WHERE tagid IN (".simplode($newids).")");
	$_SGLOBAL['db']->query("DELETE FROM ".tname('thread')." WHERE tagid IN (".simplode($newids).")");
	$_SGLOBAL['db']->query("DELETE FROM ".tname('post')." WHERE tagid IN (".simplode($newids).")");

	return $dels;
}

//ɾûĿ
function deleteprofilefield($fieldids) {
	global $_SGLOBAL;

	if(!checkperm('manageprofilefield')) return false;
	
	//ɾ
	$_SGLOBAL['db']->query("DELETE FROM ".tname('profilefield')." WHERE fieldid IN (".simplode($fieldids).")");
	//ıṹ
	foreach ($fieldids as $id) {
		$_SGLOBAL['db']->query("ALTER TABLE ".tname('spacefield')." DROP `field_$id`", 'SILENT');
	}
	
	return true;
}

//ɾĿ
function deleteprofield($fieldids) {
	global $_SGLOBAL;

	if(!checkperm('manageprofield')) return false;
	
	$dels = $newids = array();
	$query = $_SGLOBAL['db']->query("SELECT * FROM ".tname('mtag')." WHERE fieldid IN (".simplode($fieldids).")");
	while ($value = $_SGLOBAL['db']->fetch_array($query)) {
		$newids[] = $value['tagid'];
		$dels[] = $value;
	}
	//ɾ
	$_SGLOBAL['db']->query("DELETE FROM ".tname('profield')." WHERE fieldid IN (".simplode($fieldids).")");

	//mtag
	if($newids) deletemtag($newids);
	
	return true;
}

//ɾ
function deleteads($adids) {
	global $_SGLOBAL;

	if(!checkperm('managead')) return false;
	
	$dels = $newids = array();
	$query = $_SGLOBAL['db']->query("SELECT * FROM ".tname('ad')." WHERE adid IN (".simplode($adids).")");
	while ($value = $_SGLOBAL['db']->fetch_array($query)) {
		//ɾģģļ
		$tpl = S_ROOT."./data/adtpl/$value[adid].htm";//ԭʼ
		swritefile($tpl, ' ');

		$newids[] = $value['adid'];
		$dels[] = $value;
	}
	if(empty($dels)) return array();
	
	//
	$_SGLOBAL['db']->query("DELETE FROM ".tname('ad')." WHERE adid IN (".simplode($newids).")");

	return $dels;
}

//ģɾ
function deleteblocks($bids) {
	global $_SGLOBAL;

	if(!checkperm('managead')) return false;
	
	$dels = $newids = array();
	$query = $_SGLOBAL['db']->query("SELECT * FROM ".tname('block')." WHERE bid IN (".simplode($bids).")");
	while ($value = $_SGLOBAL['db']->fetch_array($query)) {
		//ɾģģļ
		$tpl = S_ROOT."./data/blocktpl/$value[bid].htm";//ԭʼ
		swritefile($tpl, ' ');

		$newids[] = $value['bid'];
		$dels[] = $value;
	}
	if(empty($dels)) return array();
	
	//
	$_SGLOBAL['db']->query("DELETE FROM ".tname('block')." WHERE bid IN (".simplode($newids).")");

	return $dels;
}

//¿ռ
function updatespaces($spaces, $type) {
	global $_SGLOBAL;

	//ռ
	if(!$credit = creditrule('pay', $type)) {
		return false;//ɾ۷
	}
	$nums = renum($spaces);
	foreach ($nums[0] as $num) {
		//
		$newcredit = $num * $credit;
		$_SGLOBAL['db']->query("UPDATE ".tname('space')." SET credit=credit-$newcredit WHERE uid IN (".simplode($nums[1][$num]).")");
		$_SGLOBAL['db']->query("UPDATE ".tname('session')." SET credit=credit-$newcredit WHERE uid IN (".simplode($nums[1][$num]).")");
	}
}

?>